from PyQt6.QtDBus import QDBusMessage, QDBusConnection, QDBusVariant
from PyQt6.QtWidgets import QApplication, QWidget
from PyQt6.QtCore import QBuffer
from PyQt6.QtGui import QIcon
import sys


def test_portal():
    buffer = QBuffer()
    QIcon.fromTheme("utilities-terminal").pixmap(512, 512).save(buffer, "PNG")

    message = QDBusMessage.createMethodCall("org.freedesktop.portal.Desktop", "/org/freedesktop/portal/desktop", "org.freedesktop.portal.DynamicLauncher", "PrepareInstall")
    message.setArguments(["", "Name", QDBusVariant(buffer), {}])
    result = QDBusConnection.sessionBus().call(message)
    print(result.errorMessage())


def main():
    app = QApplication(sys.argv)

    w = QWidget()
    w.show()

    test_portal()
    sys.exit(app.exec())


if __name__ == "__main__":
    main()
